﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using J_RFID;

namespace Jogtek
{
    public partial class Form1 : Form
    {
        RFIDAPI NFC_API = new RFIDAPI();
        int Err = 0;

        string[] UID_ID = new string[50];
        ulong[] UID_Count = new ulong[50];

        string EPC = "";
        ulong EPC_Count =0;

        public Form1()
        {
            InitializeComponent();
        }       
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                this.Text = "Jogtek NFC ";
                if (Com_Port.Text == "Open Port")
                {                   
                    // 開啟通訊埠
                    Err = NFC_API.RFID_OpenReader(ComBxTm_COM.Text);
                    if (Err != 0)
                    {
                        listBox1.Items.Add("Open COM Err " + Err);
                        return;
                    }
                    //取得 Firmware 版本 API 版本
                    string Str = "";
                    Err = NFC_API.RFID_FWVersion(out Str);
                    if (Err != 0)
                    {
                        listBox1.Items.Add("RFID_FWVersion Err  : " + Err.ToString());
                        return;
                    }
                    else
                    {
                        this.Text = this.Text + "  FW : " + Str;
                    }
                    //取得 API 版本                    
                    Str = "";
                    Err = NFC_API.RFID_GetAPIVersionString(out Str);
                    if (Err != 0)
                    {
                        listBox1.Items.Add("GetAPIVersionString Err");
                        return;
                    }
                    else
                    {
                        this.Text = this.Text + "  API : " + Str;
                    }


                    Com_Port.Text = "Close Port";
                    ComBxTm_COM.Enabled = false;
                }
                else if (Com_Port.Text == "Close Port")
                {


                    Com_Port.Text = "Open Port";
                    NFC_API.RFID_CloseReader(ComBxTm_COM.Text);
                    ComBxTm_COM.Enabled = true;
                }
            }
            catch
            {
                NFC_API.RFID_CloseReader(ComBxTm_COM.Text);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();                    
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            if (button1.Text == "polling Start")
            {
                UID_ID = new string[50];
                UID_Count = new ulong[50];
                timer1.Enabled = true;
                button1.Text = "polling Stop";
            }
            else
            {
                timer1.Enabled = false;
                button1.Text = "polling Start";
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            string outstr = "", outstr2 = "", UID15693 = "";
            int i=0;            
            //============================== 15639 ==============================
            //Half POWER 0 Full POWRE 1
            if (checkBox2.Checked == true)
            {
                if (checkBox1.Checked == true)
                    Err = NFC_API.RFID_WorkingType(0, 0);
                else
                    Err = NFC_API.RFID_WorkingType(0, 1);

                Err = NFC_API.RFID_ISO15693Inventory("24", "0", "300", out outstr);
                if (outstr.Length > 16)
                {
                    for (int U15693 = 0; U15693 < outstr.Length / 16; U15693++)
                    {
                        UID15693 = outstr.Substring(U15693 * 16, 16);                      


                            for (i = 0; i < UID_ID.Length; i++)
                            {
                                if (UID_ID[i] == UID15693)
                                {
                                    UID_Count[i] = UID_Count[i] + 1;
                                    break;
                                }
                                if (UID_ID[i] == null)
                                {
                                    UID_ID[i] = UID15693;
                                    UID_Count[i] = UID_Count[i] + 1;
                                    break;
                                }



                            }

                       
                    }
                }
                else
                {
                    if (outstr.Length > 4)
                    {


                        for (i = 0; i < UID_ID.Length; i++)
                        {
                            if (UID_ID[i] == outstr)
                            {
                                UID_Count[i] = UID_Count[i] + 1;
                                break;
                            }
                            if (UID_ID[i] == null)
                            {
                                UID_ID[i] = outstr;
                                UID_Count[i] = UID_Count[i] + 1;
                                break;
                            }



                        }

                    }
                }

            }
            //============================== 14443A ==============================
            if (checkBox3.Checked == true)
            {
                if (checkBox1.Checked == true)
                    Err = NFC_API.RFID_WorkingType(1, 0);
                else
                    Err = NFC_API.RFID_WorkingType(1, 1);

                Err = NFC_API.RFID_Get14443AUID(out outstr, out outstr2);
                if (outstr.Length > 4)
                {


                    for (i = 0; i < UID_ID.Length; i++)
                    {
                        if (UID_ID[i] == outstr)
                        {
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }
                        if (UID_ID[i] == null)
                        {
                            UID_ID[i] = outstr;
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }



                    }

                }
            }
            //============================== 14443B ==============================
            if (checkBox4.Checked == true)
            {
                if (checkBox1.Checked == true)
                    Err = NFC_API.RFID_WorkingType(2, 0);
                else
                    Err = NFC_API.RFID_WorkingType(2, 1);

                Err = NFC_API.RFID_Get14443BUID(out outstr);
                if (outstr.Length > 4)
                {


                    for (i = 0; i < UID_ID.Length; i++)
                    {
                        if (UID_ID[i] == outstr)
                        {
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }
                        if (UID_ID[i] == null)
                        {
                            UID_ID[i] = outstr;
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }



                    }

                }
            }
            //============================== 14443B SRI4K ========================
            if (checkBox5.Checked == true)
            {
                if (checkBox1.Checked == true)
                    Err = NFC_API.RFID_WorkingType(2, 0);
                else
                    Err = NFC_API.RFID_WorkingType(2, 1);

                Err = NFC_API.RFID_SRIX4KChipID(out outstr);
                Err = NFC_API.RFID_14443BSelect("03", out outstr);
                if (outstr.Length > 4)
                {


                    for (i = 0; i < UID_ID.Length; i++)
                    {
                        if (UID_ID[i] == outstr)
                        {
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }
                        if (UID_ID[i] == null)
                        {
                            UID_ID[i] = outstr;
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }



                    }

                }
            }
            //============================== Felica ==============================
            if (checkBox6.Checked == true)
            {
                if (checkBox1.Checked == true)
                    Err = NFC_API.RFID_WorkingType(3, 0);
                else
                    Err = NFC_API.RFID_WorkingType(3, 1);

                Err = NFC_API.Felica_GetPicc(out outstr);
                if (outstr.Length > 4)
                {


                    for (i = 0; i < UID_ID.Length; i++)
                    {
                        if (UID_ID[i] == outstr)
                        {
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }
                        if (UID_ID[i] == null)
                        {
                            UID_ID[i] = outstr;
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }



                    }

                }
            }
            //================================================================

            listBox1.Items.Clear();
            for (i = 0; i < UID_ID.Length; i++)
            {
                if (UID_ID[i] != null)                
                    listBox1.Items.Add(UID_ID[i] + "  " + UID_Count[i]);                
            }

            listBox1.TopIndex = listBox1.Items.Count.GetHashCode() - 1;
            
        }

        private void button3_Click(object sender, EventArgs e)
        {
            NFC_API.RFID_AntennaControl(1);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            NFC_API.RFID_AntennaControl(0);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            checkBox2.Checked = true;
            checkBox3.Checked = true;
            checkBox4.Checked = true;
            checkBox5.Checked = true;
            checkBox6.Checked = true;
            
        }

        private void button5_Click(object sender, EventArgs e)
        {
            checkBox2.Checked = false;
            checkBox3.Checked = false;
            checkBox4.Checked = false;
            checkBox5.Checked = false;
            checkBox6.Checked = false;
            
        }



        private void Form1_Load(object sender, EventArgs e)
        {
            string[] strAryCom = null;

            strAryCom = SerialPort.GetPortNames();

            for (int i = 0; i < strAryCom.Length; i++)
            {
                ComBxTm_COM.Items.Add((object)strAryCom[i]);
            }
            if (ComBxTm_COM.Items.Count > 0 && ComBxTm_COM.Text == "") ComBxTm_COM.Text = ComBxTm_COM.Items[0].ToString();
        }

      

       

       

       

        private void button15_Click(object sender, EventArgs e)
        {
            if (Polling15693.Text == "polling Start")
            {
                UID_ID = new string[50];
                UID_Count = new ulong[50];
                timer2.Enabled = true;
                timer1.Enabled = false;
                Polling15693.Text = "polling Stop";
            }
            else
            {
                timer2.Enabled = false;
                Polling15693.Text = "polling Start";
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            string outstr = "", UID15693 = "";
            int i = 0;
            //============================== 15639 ==============================           
            Err = NFC_API.RFID_ISO15693Inventory("24", "0", comboBox1.Text, out outstr);
            if (outstr.Length > 16)
            {
                for (int U15693 = 0; U15693 < outstr.Length / 16; U15693++)
                {
                    UID15693 = outstr.Substring(U15693 * 16, 16);


                    for (i = 0; i < UID_ID.Length; i++)
                    {
                        if (UID_ID[i] == UID15693)
                        {
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }
                        if (UID_ID[i] == null)
                        {
                            UID_ID[i] = UID15693;
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }



                    }


                }
            }
            else
            {
                if (outstr.Length > 4)
                {


                    for (i = 0; i < UID_ID.Length; i++)
                    {
                        if (UID_ID[i] == outstr)
                        {
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }
                        if (UID_ID[i] == null)
                        {
                            UID_ID[i] = outstr;
                            UID_Count[i] = UID_Count[i] + 1;
                            break;
                        }



                    }

                }
            }



            listBox3.Items.Clear();
            for (i = 0; i < UID_ID.Length; i++)
            {
                if (UID_ID[i] != null)
                    listBox3.Items.Add(UID_ID[i] + "  " + UID_Count[i]);
            }

            listBox3.TopIndex = listBox3.Items.Count.GetHashCode() - 1;
        }

        private void button14_Click(object sender, EventArgs e)
        {
            //Half POWER 0 Full POWRE 1           
            if (checkBox8.Checked == true)
                Err = NFC_API.RFID_WorkingType(0, 0);
            else
                Err = NFC_API.RFID_WorkingType(0, 1);

            listBox3.Items.Add("SetProtocol OK");
            listBox3.TopIndex = listBox3.Items.Count.GetHashCode() - 1;
        }

        private void button11_Click(object sender, EventArgs e)
        {
            listBox3.Items.Clear();
        }

        private void button13_Click(object sender, EventArgs e)
        {
            string Data = "", UID = "";

            if (checkBox9.Checked == true)//RFID_MB89R118
                Err = NFC_API.RFID_MB89R118Read("00", "", textBox6.Text, out Data);
            else if (checkBox13.Checked == true)//RFID_MB892R112
            {
                NFC_API.RFID_ISO15693Inventory("24", "0", "250", out UID);
                Err = NFC_API.RFID_MB89R112Read("20", UID, textBox6.Text, out Data);
            }
            else
                Err = NFC_API.RFID_ISO15693Read("00", "", textBox6.Text, out Data);

            if (Err != 0)
            {
                listBox3.Items.Add("Err : " + Err);
                return;
            }
            listBox3.Items.Add("Data : " + Data);
            listBox3.TopIndex = listBox3.Items.Count.GetHashCode() - 1;
        }

        private void button12_Click(object sender, EventArgs e)
        {
            string Data = "", UID;
            Data = textBox4.Text + "0000000000000000000000000000000000000000000000000000000000000000";

            if (checkBox9.Checked == true)//RFID_MB89RWrite
            {
                if (checkBox7.Checked == true)
                    Err = NFC_API.RFID_MB89RWrite("40", "", textBox5.Text, Data.Substring(0, 16));
                else
                    Err = NFC_API.RFID_MB89RWrite("00", "", textBox5.Text, Data.Substring(0, 16));
            }
            else if (checkBox13.Checked == true)//RFID_MB892R112
            {
                NFC_API.RFID_ISO15693Inventory("24", "0", "250", out UID);

                if (checkBox7.Checked == true)
                    Err = NFC_API.RFID_MB89R112Write("60", UID, textBox5.Text, Data.Substring(0, 64));
                else
                    Err = NFC_API.RFID_MB89R112Write("20", UID, textBox5.Text, Data.Substring(0, 64));
            }
            else
            {
                if (checkBox7.Checked == true)
                    Err = NFC_API.RFID_ISO15693Write("40", "", textBox5.Text, Data.Substring(0, 8));
                else
                    Err = NFC_API.RFID_ISO15693Write("00", "", textBox5.Text, Data.Substring(0, 8));
            }

            listBox3.Items.Add("OK");
            listBox3.TopIndex = listBox3.Items.Count.GetHashCode() - 1;
        }

        private void button15_Click_1(object sender, EventArgs e)
        {
            string Uid = "", CardType = ""; ;
            A_UID.Text = "UID :";
            Err = NFC_API.RFID_OpenCard(out Uid, out CardType);
            if (Err != 0)
            {
                listBox4.Items.Add("Err : " + Err);                
                return;
            }            
            A_UID.Text = Uid;            
            listBox4.Items.Add("CardType : " + CardType);
            listBox4.TopIndex = listBox4.Items.Count.GetHashCode() - 1;
           
        }

        private void button16_Click(object sender, EventArgs e)
        {
            string Data = "";
            string Uid = A_UID.Text;
                   
            
            if (KeyA.Checked == true)
                Err = NFC_API.RFID_ReadMifareOneBlock(0, 0, 0, textBox7.Text, Key.Text, out Data);      


            if (KeyB.Checked == true)
                Err = NFC_API.RFID_ReadMifareOneBlock(1, 0, 0, textBox7.Text, Key.Text, out Data);


            if (Err != 0)
            {
                listBox4.Items.Add("Err : " + Err);
                return;
            }

            listBox4.Items.Add(Data);
            listBox4.TopIndex = listBox4.Items.Count.GetHashCode() - 1;
        }

        private void button18_Click(object sender, EventArgs e)
        {
            listBox4.Items.Clear();
        }

        private void button17_Click(object sender, EventArgs e)
        {
            string Date = "";
            //
            string Uid = A_UID.Text;            
            //
            Date = WriteData.Text + "00000000000000000000000000000000";
            if (KeyA.Checked == true)
                Err = NFC_API.RFID_WriteMifareOneBlock(0, 0, 0, textBox7.Text, Key.Text, Date.Substring(0, 32));

            if (KeyB.Checked == true)
                Err = NFC_API.RFID_WriteMifareOneBlock(1, 0, 0, textBox7.Text, Key.Text, Date.Substring(0, 32));


            if (Err != 0)
            {
                listBox4.Items.Add("Err : " + Err);                
                return;
            }
            listBox4.Items.Add("Write OK");
            listBox4.TopIndex = listBox4.Items.Count.GetHashCode() - 1;

        }

        private void button21_Click(object sender, EventArgs e)
        {
            listBox5.Items.Clear();
        }

        private void button20_Click(object sender, EventArgs e)
        {
            string Data = "", Block = "";
            if (textBox9.Text.Length < 2) Block = "0" + textBox9.Text.Length;
            else Block = textBox9.Text;

            Err = NFC_API.RFID_ReadUltraLightBlock(Block, out Data);
            if (Err > 0)
                listBox5.Items.Add("Err : " + Err);  
            else
                listBox5.Items.Add("Data : " + Data);
            listBox5.TopIndex = listBox5.Items.Count.GetHashCode() - 1;
        }

        private void button19_Click(object sender, EventArgs e)
        {
            string Data = "", Block = "";

            if (textBox9.Text.Length < 2) Block = "0" + textBox9.Text.Length;
            else Block = textBox9.Text;

            Data = textBox8.Text + "00000000";
            Data = Data.Substring(0, 8);
            Err = NFC_API.RFID_WriteUltraLightBlock(Block, Data);
            if (Err != 0)
                listBox5.Items.Add("Err : " + Err);
            else
                listBox5.Items.Add("Write OK");
            listBox5.TopIndex = listBox5.Items.Count.GetHashCode() - 1;
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox9.Checked == true)
            {
                textBox4.MaxLength = 16;
                textBox4.Text = "0000000000000000";
                checkBox13.Checked = false;

            }
            else if (checkBox9.Checked == false && checkBox13.Checked == false)
            {
                textBox4.MaxLength = 8;
                textBox4.Text = "00000000";
            }
        }

       

       

        private void button23_Click(object sender, EventArgs e)
        {
            if (checkBox10.Checked == true)
                Err = NFC_API.RFID_WorkingType(3,0);
            else
                Err = NFC_API.RFID_WorkingType(3,1);

            if (Err != 0)
            {
                listBox6.Items.Add("Err : " + Err);
                return;
            }
            listBox6.Items.Add("SetProtocol OK");
            listBox6.TopIndex = listBox6.Items.Count.GetHashCode() - 1;
        }

        private void button24_Click(object sender, EventArgs e)
        {
            string outstr = ""; 
            Err = NFC_API.Felica_GetPicc(out outstr);
            if (Err != 0)
            {
                listBox6.Items.Add("Felica GetPicc Err ");
                return;
            }
            PICC.Text = outstr;
            listBox6.Items.Add(outstr);
            listBox6.TopIndex = listBox6.Items.Count.GetHashCode() - 1;
        }

        private void button26_Click(object sender, EventArgs e)
        {
            string Picc = "";
            string outstr = "";

            Err = NFC_API.Felica_GetPicc(out outstr);
            if (Err != 0)
            {
                listBox6.Items.Add("Felica GetPicc Err ");
                return;
            }
            PICC.Text = outstr;
            Picc = outstr;


            string Block = "";
            Block = textBox12.Text;
            if (Block.Length < 2) Block = "0" + Block;

            Err = NFC_API.Felica_Read(Block, Picc, out outstr);
            if (Err != 0)
            {
                listBox6.Items.Add("Felica Read Err ");
                return;
            }

            listBox6.Items.Add("Block " + Block + " : " + outstr);
            listBox6.TopIndex = listBox6.Items.Count.GetHashCode() - 1;
        }

        private void button27_Click(object sender, EventArgs e)
        {
            listBox6.Items.Clear();
        }

        private void button25_Click(object sender, EventArgs e)
        {
            string Picc = "";
            string outstr = "";

            PICC.Text = "";
            Err = NFC_API.Felica_GetPicc(out outstr);
            if (Err != 0)
            {
                listBox6.Items.Add("Felica GetPicc Err ");
                return;
            }
            PICC.Text = outstr;
            Picc = outstr;


            string Block = "";
            Block = textBox11.Text;
            if (Block.Length < 2) Block = "0" + Block;

            Err = NFC_API.Felica_Write(Block, Picc, textBox10.Text, out outstr);
            if (Err != 0)
            {
                listBox6.Items.Add("Felica Write Err ");
                return;
            }
            listBox6.Items.Add("Felica Write");
            listBox6.TopIndex = listBox6.Items.Count.GetHashCode() - 1;
        }

        private void button31_Click(object sender, EventArgs e)
        {
            if (checkBox11.Checked == true)
                Err = NFC_API.RFID_WorkingType(2, 0);
            else
                Err = NFC_API.RFID_WorkingType(2, 1);

            if (Err != 0)
            {
                listBox7.Items.Add("Err : " + Err);
                listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
                return;
            }
            listBox7.Items.Add("SetProtocol OK");
            listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
        }

        private void button30_Click(object sender, EventArgs e)
        {
            string tmp = "";

            Err = NFC_API.RFID_SRIX4KChipID(out tmp);

            if (Err != 0)
            {
                listBox7.Items.Add("Err : " + Err);
                listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
                return;
            }
            label16.Text = "Chip ID : " + tmp;
            listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
        }

        private void button32_Click(object sender, EventArgs e)
        {
            string tmp = "";

            Err = NFC_API.RFID_14443BSelect("03", out tmp);

            if (Err != 0)
            {
                listBox7.Items.Add("Err : " + Err);
                listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
                return;
            }
            listBox7.Items.Add(tmp);
            listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            NFC_API.RFID_CloseReader(ComBxTm_COM.Text);
        }

        private void button33_Click(object sender, EventArgs e)
        {
            listBox7.Items.Clear();
        }

        private void button29_Click(object sender, EventArgs e)
        {
            string Data = "";

            Err = NFC_API.RFID_SRIX4KReadBlock(textBox15.Text, out Data);

            if (Err != 0)
            {
                listBox7.Items.Add("Err : " + Err);
                listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
                return;
            }

            listBox7.Items.Add(Data);
            listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
        }

        private void button28_Click(object sender, EventArgs e)
        {
            string Data = "";

            Data = textBox13.Text + "00000000";
            Data = Data.Substring(0, 8);

            Err = NFC_API.RFID_SRIX4KWriteBlock(textBox14.Text, Data);

            if (Err != 0)
            {
                listBox7.Items.Add("Err : " + Err);
                listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;
                return;                
            }
            listBox7.Items.Add("Write Data");
            listBox7.TopIndex = listBox7.Items.Count.GetHashCode() - 1;            
        }

        private void button34_Click(object sender, EventArgs e)
        {
            //Half POWER 0 Full POWRE 1           
            if (checkBox12.Checked == true)
                Err = NFC_API.RFID_WorkingType(1, 0);
            else
                Err = NFC_API.RFID_WorkingType(1, 1);

            listBox8.Items.Add("SetProtocol OK");
            listBox8.TopIndex = listBox8.Items.Count.GetHashCode() - 1;
        }

        private void button35_Click(object sender, EventArgs e)
        {
            string outstr = "", outstr2 = "";

            Err = NFC_API.RFID_Get14443AUID(out outstr, out outstr2);
            if (Err != 0)
            {
                listBox8.Items.Add("Err : " + Err);
                listBox8.TopIndex = listBox8.Items.Count.GetHashCode() - 1;
                return;
            }
            listBox8.Items.Add(outstr);
            listBox8.TopIndex = listBox8.Items.Count.GetHashCode() - 1;
        }

        private void button37_Click(object sender, EventArgs e)
        {
            string Data = "";

            Err = NFC_API.NTAG_Read(textBox18.Text, out Data);

            if (Err != 0)
            {
                listBox8.Items.Add("Err : " + Err);
                listBox8.TopIndex = listBox8.Items.Count.GetHashCode() - 1;
                return;
            }
            listBox8.Items.Add("Data : " + Data);
            listBox8.TopIndex = listBox8.Items.Count.GetHashCode() - 1;
        }

        private void button36_Click(object sender, EventArgs e)
        {            
            Err = NFC_API.NTAG_Write(textBox17.Text, textBox16.Text);

            if (Err != 0)
            {
                listBox8.Items.Add("Err : " + Err);
                listBox8.TopIndex = listBox8.Items.Count.GetHashCode() - 1;
                return;
            }
            listBox8.Items.Add("Write Data");
            listBox8.TopIndex = listBox8.Items.Count.GetHashCode() - 1;
        }

     

        private void button39_Click(object sender, EventArgs e)
        {
            string[] strAryCom = null;
            ComBxTm_COM.Items.Clear();           
            ComBxTm_COM.Text = "";
           

            strAryCom = SerialPort.GetPortNames();

            for (int i = 0; i < strAryCom.Length; i++)
            {
                ComBxTm_COM.Items.Add((object)strAryCom[i]);
                
            }
            if (ComBxTm_COM.Items.Count > 0 && ComBxTm_COM.Text == "") ComBxTm_COM.Text = ComBxTm_COM.Items[0].ToString();            

        }

        private void checkBox13_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox13.Checked == true)
            {
                textBox4.MaxLength = 64;
                textBox4.Text = "0000000000000000000000000000000000000000000000000000000000000000";
                checkBox9.Checked = false;

            }
            else if (checkBox9.Checked == false && checkBox13.Checked == false)
            {
                textBox4.MaxLength = 8;
                textBox4.Text = "00000000";
            }
        }

       
      































       
    }
}
